unit main2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RDX, StdCtrls, ExtCtrls, mmsystem, dxint, Buttons, WSockets, Winsock;

type
  TForm1 = class(TForm)
    RenderDX1: TRenderDX;
    Memo1: TMemo;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    TCPClient1: TTCPClient;
    TCPServer1: TTCPServer;
    GroupBox1: TGroupBox;
    Button4: TButton;
    Button5: TButton;
    Label2: TLabel;
    Edit1: TEdit;
    GroupBox2: TGroupBox;
    Edit2: TEdit;
    Label3: TLabel;
    Button6: TButton;
    Button7: TButton;
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RenderDX1SectorEntry(Sender: TObject; ActorNo,
      SectorNo: Integer);
    procedure RenderDX1LineCross(Sender: TObject; ActorNo, line,
      sector: Integer);
    procedure RenderDX1ActorCross(Sender: TObject; MovActor,
      CrossedActor: Integer);
    procedure Button4Click(Sender: TObject);
    procedure TCPServer1Accept(Sender: TObject; Socket: Integer);
    procedure TCPServer1Close(Sender: TObject; Socket: Integer);
    procedure TCPServer1Data(Sender: TObject; Socket: Integer);
    procedure TCPServer1Error(Sender: TObject; Error: Integer;
      Msg: string);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure TCPClient1Close(Sender: TObject; Socket: Integer);
    procedure TCPClient1Connect(Sender: TObject; Socket: Integer);
    procedure TCPClient1Data(Sender: TObject; Socket: Integer);
    procedure TCPClient1Error(Sender: TObject; Error: Integer;
      Msg: string);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    original_pal : hPalette;
    procedure AppIdle(Sender: TObject; var Done: Boolean);
    procedure MoveStuff;
    procedure MoveRobots;
  public
    ouractor  : integer;
    Rotating  : integer;          // directional movement flags
    Moving    : integer;
    Shearing  : integer;
    tickcount : integer;          // this is the frame tick count.
    tickerr   : integer;          // we accumulate errors here, so that the
                                  // movement is smooth.
    StartTime,EndTime : integer;  // For Timing viewpoint actor moves.
    robomove  : integer;          // Timing robot moves.
    Shear     : integer;          // looking up and down
    Velocity  : integer;          // moving forward/backward
    Spin      : integer;          // angles turning
    MaxVelocity  : integer;

    servermode   : boolean;       // keep track of if we are a server or client
    have_the_gun : boolean;
    SectorList   : TList;         // place to store all the sector movements
    TeleportList : TList;         // place to store all the teleporting people

    procedure SendTCP(msg : string);
    procedure SendActor(pa : pActor);
    procedure ProcessOutput(data : pointer);
    procedure ProcessInput(p : pointer);
    function  GetPalette : hPalette; override;
    procedure TripLine(pl:pLinedef;pa : pActor);
    procedure MsgOut(msg: string);
  end;

// Teleport list is used to keep track of
// who is teleporting where.
type pTeleportList = ^TeleportList;
     TeleportList  = record
        pa    : pActor;
        x,y,z : single;
        s     : integer;
     end;

// MoveList is used to keep track of doors and
// elevators.
type pMoveList = ^movelist;
     movelist  = record
        raisingc  : boolean;
        raisingf  : boolean;
        loweringc : boolean;
        loweringf : boolean;
        ps        : psector;
        left      : integer;
     end;

type pPackActr = ^PackActr;
     PackActr = record
        packtype : char;
        num      : word;
        x,y,z    : single;
        sect     : integer;
        angle    : integer;
     end;

type pPackSect = ^PackSect;
     PackSect = record
        packtype : char;
        flags    : integer;
        sector   : integer;
        left     : integer;
     end;

type pPackData = ^PackData;
     PackData = record
        packtype : char;
        packdata : array [0..30] of byte;
     end;

var
  Form1: TForm1;
  packd : PackData;
  packa : PackActr;
  packs : packsect;

//procedure dx_getfacingline(x)

implementation

{$R *.DFM}

function TForm1.GetPalette : hPalette;
begin
   result :=  hPalette(renderdx1.palette);
end;

procedure TForm1.MoveRobots;
var us    : pactor;
    x,y,z,sect : integer;
begin
    robomove := robomove + tickcount;
    if robomove > 4 then begin
        dec(robomove,4);
        us := pactor(renderdx1.getactor(ouractor));
        // send our updated coordinates to the other player
        SendActor(us);
    end;
end;

procedure TForm1.SendActor(pa : pActor);
begin
    Packa.packtype := '1';
    packa.num := pa.number;
    packa.x := pa.x;
    packa.y := pa.y;
    packa.z := pa.height;
    packa.sect := pa.sector;
    packa.angle := pa.angle;
    CopyMemory(@packd,@packa,sizeof(packa));
    ProcessOutput(@packd);
end;

procedure TForm1.SendTCP(msg : string);
var i : integer;
begin
    packd.packtype := '4';
    for i := 0 to 30 do packd.packdata[i] := 32;
    for i := 1 to length(msg) do packd.packdata[i-1] := byte(msg[i]);
    ProcessOutput(@packd);
end;

procedure TForm1.MoveStuff;
var NeedPack : boolean;
    pm : pMoveList;
    pt : pTeleportList;
    i,amt : integer;
begin
   if teleportlist.count > 0 then begin
      for i := 0 to teleportlist.count -1 do begin
          pt := teleportlist.items[i];
          RenderDX1.positionActor(pt.pa.number,pt.x,pt.y,pt.z,0);
          Dispose(pt);
          teleportlist.delete(i);
      end;
      teleportlist.pack;
   end;

   if sectorlist.count > 0 then begin
      NeedPack := false;
      // lets check all the sectors in this list and see if they need
      // to be raised or lowered.
      for i := 0 to sectorlist.count-1 do begin
          pm := sectorlist.items[i];
          amt := tickcount;
          if amt > pm.left then amt := pm.left;

          if pm.raisingf then begin
             pm.ps.floorht := pm.ps.floorht + amt;
          end;

          if pm.raisingc then begin
             pm.ps.ceilht := pm.ps.ceilht + amt;
          end;

          if pm.loweringf then begin
             pm.ps.floorht := pm.ps.floorht - amt;
          end;

          if pm.loweringc then begin
             pm.ps.ceilht := pm.ps.ceilht - amt;
          end;

          dec(pm.left,amt);
          if pm.left < 0 then begin
             // Don't need this one, lets delete it
             Dispose(pm);
             sectorlist.delete(i);
             Needpack := true;
          end;
      end;
      // if any were removed from the list, then the list is packed.
      if NeedPack then SectorList.Pack;
   end;
end;

procedure TForm1.AppIdle(Sender: TObject; var Done: Boolean);
var ctr : integer;
    remain : integer;
    erraccum : integer;
begin
    Done := False;
    StartTime := EndTime;
    RenderDX1.Render(0,0);
    Application.ProcessMessages;
    RenderDX1.Repaint;
    EndTime   := TimeGetTime; // count in milliseconds
    ctr       := EndTime - StartTime; // ctr = # of milliseconds since last render
    TickCount := ctr shr 4;           // div 16
    remain    := ctr - (ctr  shl 4);  // mod 16
    tickerr   := Tickerr + remain;    // accumulate error
    if tickerr >= 16 then begin       // pull 'whole ticks' off err
       erraccum  := tickerr shl 4;
       tickcount := tickcount + erraccum;
       tickerr   := tickerr - (erraccum shr 4);
    end;
    // First take care of mundane tasks.
    // Move any doors / elevators that need to move.
    MoveStuff;
    // move any actors that need to chase me.
    MoveRobots;

    if moving <> 0 then begin
       // speed up
       inc(velocity,moving*tickcount);
       if velocity >  maxvelocity then velocity :=  maxvelocity;
       if velocity < -maxvelocity then velocity := -maxvelocity;
    end else begin
       // slow down
       if velocity > 0 then begin
          if velocity >= tickcount then dec(velocity,tickcount) else velocity := 0;
       end;
       if velocity < 0 then begin
          if velocity <= (-tickcount) then inc(velocity,tickcount) else velocity := 0;
       end;
    end;

    if rotating <> 0 then begin
       // speed up rotation
       inc(spin,rotating*tickcount);
       if spin >  12 then spin :=  12;
       if spin < -12 then spin := -12;
    end else begin
       // slow down rotation
       if spin >  0 then begin
          if spin >= tickcount then dec(spin,tickcount) else spin := 0;
       end;
       if spin <  0 then begin
         if spin <= (-tickcount)then inc(spin,tickcount) else spin := 0;
       end;
    end;

    if shearing <> 0 then begin
       // Look farther up and down
       inc(shear,shearing*tickcount*4);
       if shear >  200 then shear :=  200;
       if shear < -200 then shear := -200;
    end else begin
       // Move view back toward center.
       if shear >  0 then
          if shear >= (tickcount *4) then dec(shear,tickcount*4) else shear := 0;
       if shear <  0 then
          if shear <= (tickcount *-4) then inc(shear,tickcount*4) else shear := 0;
    end;
    // move viewpoint, spin, and shear the view.
    if velocity <> 0 then begin
       RenderDX1.MoveActor(ouractor,velocity);
    end;
    if spin <> 0 then begin
       RenderDX1.SpinActor(ouractor,Spin);
    end;
    RenderDX1.Shear := shear;
    RenderDX1.CheckActor(ouractor);
    sleep(1);
end;

// DoType = 1000 = raise ceiling of sector
// saved height in tripflags1
// DoTag  = 111 = use sector(s) with tag 111


procedure TForm1.TripLine(pl:pLinedef;pa : pActor);
var pm : pMoveList;
    pT : pTeleportList;
    ps : pSector;
    i  : integer;
begin
    // These "DoTypes" are all arbitrary. I just made them up. Make up
    // your own that fits your needs.
    case pl.dotype of
        999 : begin
              // we add the teleport victims to a list,
              // because if we do it here, it won't work -
              // the move routine that set the trigger off will
              // overwrite the coordinates we put in.
              ps := pSector(RenderDX1.getsector(pl.trip3));
              new(pt);
              pt.pa := pa;
              pt.x := pl.trip1;
              pt.y := pl.trip2;
              pt.z := ps.floorht+96;
              pt.s := pl.trip3;
              teleportlist.add(pt);
              end;
       1000 : begin
                 // Tag type 1000 will raise a sectors ceiling by what is in trip1.
                 for i := 0 to dx_maxsectors -1 do begin
                    ps := pSector(RenderDX1.getsector(i));
                    if ps <> nil then
                    if ps.tag = pl.dotag then begin
                       New(PM);
                       pm.ps := ps;
                       pm.left := pl.trip1;
                       pm.raisingc := true;
                       pm.raisingf := false;
                       pm.loweringc := false;
                       pm.loweringf := false;
                       SectorList.Add(pm);
                    end;
                 end;
              end;
       1001 : begin
                 for i := 0 to dx_maxsectors -1 do begin
                    ps := pSector(RenderDX1.getsector(i));
                    if ps <> nil then
                    if ps.tag = pl.dotag then begin
                       New(PM);
                       pm.ps := ps;
                       pm.left := pl.trip1;
                       pm.raisingc := false;
                       pm.raisingf := true;
                       pm.loweringc := false;
                       pm.loweringf := false;
                       SectorList.Add(pm);
                    end;
                 end;
              end;
    end;

end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var pa : pactor;
    pl : pLineDef;
begin
     case Key of
         VK_SPACE: begin
                   // Jump!
                   pa := pActor(RenderDx1.GetActor(ouractor));
                   pa.vertforce := -20;
                   key := 0;
                   end;
        VK_RETURN: begin
                   // Activate something.
//                   pl := dx_getfacingline(ouractor,128);
                   // see if we are actually looking at a line
                   if pl <> nil then begin
                       // see if it has a "trip activate" flag on it.
                      if (pl.flags and 4) = 4 then begin
                          // remove the "trip activate" if it is a "trip once" line.
                          if (pl.tripflags and $10) = $10 then pl.flags := pl.flags and (not 4);
                          pa := pActor(RenderDX1.Getactor(ouractor));
                          TripLine(pl,pa);
                      end;
                   end;
                   key := 0;
                   end;
         VK_UP:    begin moving   :=  1; key := 0; end;
         VK_DOWN:  begin moving   := -1; key := 0; end;
         VK_LEFT:  begin rotating := -1; key := 0; end;
         VK_RIGHT: begin rotating :=  1; key := 0; end;
         VK_PRIOR: begin shearing := -1; key := 0; end;
         VK_NEXT:  begin shearing :=  1; key := 0; end;
     end;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     case Key of
         VK_UP:    moving   :=  0;
         VK_DOWN:  moving   :=  0;
         VK_LEFT:  rotating :=  0;
         VK_RIGHT: rotating :=  0;
         VK_PRIOR: shearing :=  0;
         VK_NEXT:  shearing :=  0;
     end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var dirname : string;
begin
    Sectorlist := TList.Create;
    TeleportList := TList.Create;
    dirname := ExtractFilePath(application.exename);
    dirname := dirname+'..\demogrx\';
    MaxVelocity := 18;
    RenderDX1.FlatSet    := dirname+'default.flt';   // or whatever you saved the flatset as.
    RenderDX1.BitmapSet  := dirname+'default.bst';   // bitmap set, whatever you saved it as.
    RenderDX1.TextureSet := dirname+'default.tdf';   // texture definitions
    RenderDX1.ActorDefs  := dirname+'default.typ';   // Actor Type definitions
    RenderDX1.Level      := dirname+'demo2.4dx';     // the actual map level
    EndTime := TimeGetTime;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Application.OnIdle := nil;
    SectorList.Free;
    TeleportList.Free;
end;

procedure TForm1.RenderDX1SectorEntry(Sender: TObject; ActorNo,
  SectorNo: Integer);
var ps : psector;
begin
    ps := pSector(RenderDx1.getsector(SectorNo));
    // Entering any sector with a tag 555 will cause the light to get
    // lower in that sector
    if ps.tag        = 555 then begin
       ps.tag        := 0;
       ps.lightlevel := 20;
    end;
end;

procedure TForm1.RenderDX1LineCross(Sender: TObject; ActorNo, line,
  sector: Integer);
var pa : pActor;
    pl : pLineDef;
begin
   // We tripped a line with the notify flag set on it.
   pa := pActor(RenderDX1.Getactor(ActorNo));
   pl := pLineDef(line);
   // remove the "trip notify" if it is a "trip once" line.
   if (pl.tripflags and $10) = $10 then pl.flags := pl.flags and (not $400);
   TripLine(pl,pa);
end;

procedure TForm1.RenderDX1ActorCross(Sender: TObject; MovActor,
  CrossedActor: Integer);
var pa : pactor;
begin
     // someone just crossed an actor, lets check to see if it was the gun.
     // And make sure it was our character that crossed it. (We don't want
     // the robot to get the gun, now do we?
     if movactor = 0 then begin
        pa := pActor(RenderDX1.getactor(crossedactor));
        if pa.actortype = 2 then begin
           // its a gun - lets remove it from the map.
           pa.used := 0;
           have_the_gun := true;
           label1.caption := 'You have the gun!';
        end;
     end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
    // Server listen.
    servermode := true;
    ouractor   := 2;
    RenderDX1.PovActor(ouractor);
    with TCPServer1 do begin
       Port:= Edit1.Text;
       Open;
       if SocketState = ssListening then begin
          MsgOut('Local IP Address:'+LocalHostAddress+' Listening on port: '+Port);
          edit1.enabled := false;
          edit2.enabled := false;
          button5.enabled := true;
          button4.enabled := false;
          button6.enabled := false;
          button7.enabled := false;
       end;
    end;
    form1.setfocus;
end;

procedure TForm1.MsgOut(msg: string);
begin
  with Memo1.Lines do
    begin
      if Count > 200 then Delete(0);
      Add(Msg);
    end;
end;

procedure TForm1.ProcessOutput(data : pointer);
begin
    if servermode then
        TCPServer1.WriteBuffer(TcpServer1.Clients[0],data,32)
    else
        TCPClient1.WriteBuffer(data,32);
end;

procedure TForm1.ProcessInput(p : pointer);
var i,oldx,oldy : integer;
    pa : pactor;
    pd  : pPackData;
    pda : pPackActr;
    outstr : string[32];
begin
    pd := p;
    case pd.PackType of
        '1' : begin
              pda := p;
              pa   := pActor(RenderDX1.GetActor(pda^.num));
              oldx := trunc(pa.x);
              oldy := trunc(pa.y);
              if pa.actortype = 1 then begin
                 if (oldx <> pda.x) or (oldy <> pda.y) then begin
                    inc(pa.currframe);
                    if pa.currframe > 4 then pa.currframe := 0;
                 end;
              end;
              RenderDx1.positionActor(pda.num,pda.x,pda.y,pda.z,pda.sect);
              pa.height := pda.z;
              pa.angle  := pda.angle;
              end;
        '2' : ;
        '3' : ;
        '4' : begin
              outstr := '                             ';
              for i := 0 to 30 do begin
                 outstr[i+1] := char(pd.packdata[i]);
              end;
              MsgOut(outstr);
              end;
    end;
end;

procedure TForm1.TCPServer1Accept(Sender: TObject; Socket: Integer);
begin
    with tcpserver1 do begin
       Write(Socket, '4*Connection accepted RenderDX Demo! Terima Kasih!');
       MsgOut('New connection accepted for '+PeerToAddress(Socket)+' on port '+PeerToPort(Socket));
    end;
    button1.enabled := true;
    button2.enabled := true;
    button3.enabled := true;
    Application.OnIdle := AppIdle;
end;

procedure TForm1.TCPServer1Close(Sender: TObject; Socket: Integer);
begin
    button1.enabled := false;
    button2.enabled := false;
    button3.enabled := false;
    button4.enabled := true;
    button5.enabled := false;
    with TCPServer1 do
    begin
      MsgOut('Connection closed by '+PeerToAddress(Socket)+' on port '+PeerToPort(Socket));
    end;
end;

procedure TForm1.TCPServer1Data(Sender: TObject; Socket: Integer);
var instring : string;
    RC : integer;
begin
    RC:= TCPServer1.ReadBuffer(socket,@packd,32);
    while (RC <> 0) and (RC <> SOCKET_ERROR) do begin
        ProcessInput(@packd);
        RC:= TCPServer1.ReadBuffer(socket,@packd,32);
    end;
end;

procedure TForm1.TCPServer1Error(Sender: TObject; Error: Integer;
  Msg: string);
begin
   MessageDlg(Msg, mtError, [mbOK], 0);
   Application.OnIdle := nil;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
    TCPServer1.Close;
    Application.OnIdle := nil;
    button4.enabled := true;
    button5.enabled := false;
    button1.enabled := false;
    button2.enabled := false;
    button3.enabled := false;
    MsgOut('**Stopped listening');
    form1.setfocus;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  with TCPClient1 do
    begin
      //Authorized:= true;
      Host:= Edit2.Text;
      Port:= Edit1.Text;
      MsgOut('Trying to connect to '+Host+' at port '+Port);
      Open;
      if SocketState = ssOpen then
        begin
          Edit1.Enabled:= false;
          Edit2.Enabled:= false;
          Button1.Enabled:= true;
          Button2.Enabled:= true;
          Button3.Enabled:= true;
          Button4.Enabled:= false;
          Button5.Enabled:= false;
          Button6.Enabled:= false;
          Button7.Enabled:= true;
        end;
    end;
    form1.setfocus;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
    Application.OnIdle := nil;
    tcpclient1.close;
    MsgOut('Connection closed');
    Button1.Enabled:= false;
    Button2.Enabled:= false;
    Button3.Enabled:= false;
    Button6.Enabled:= true;
    Button7.Enabled:= false;
    form1.setfocus;
end;

procedure TForm1.TCPClient1Close(Sender: TObject; Socket: Integer);
begin
    Application.OnIdle := nil;
    TCPClient1.Close;
    Button1.Enabled:= false;
    Button2.Enabled:= false;
    Button3.Enabled:= false;
    Button6.Enabled:= true;
    Button7.Enabled:= false;
end;

procedure TForm1.TCPClient1Connect(Sender: TObject; Socket: Integer);
begin
  with TCPClient1 do
    begin
      MsgOut('Connected on local port '+SocketToPort(LocalSocket));
      Application.OnIdle := AppIdle;
    end;
end;

procedure TForm1.TCPClient1Data(Sender: TObject; Socket: Integer);
var RC: integer;
begin
    RC:= TCPClient1.ReadBuffer(@packd,32);
    while (RC <> 0) and (RC <> SOCKET_ERROR) do begin
        ProcessInput(@packd);
        RC:= TCPClient1.ReadBuffer(@packd,32);
    end;
end;

procedure TForm1.TCPClient1Error(Sender: TObject; Error: Integer; Msg: string);
begin
   MessageDlg(Msg, mtError, [mbOK], 0);
   Application.OnIdle := nil;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     SendTCP('Your mother dresses you funny!');
     form1.setfocus;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     SendTCP('What a cool gun you have.');
     form1.setfocus;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     SendTCP('Please don''t kill me.');
     form1.setfocus;
end;

end.
